<?php

class UserAlert extends Entity {
  public function __construct($values = array()) {
    parent::__construct($values, 'user_alert');
  }

  protected function defaultLabel() {
    if ($this->label) {
      return t('@title', array(
          '@title' => $this->field_user_alert_message[LANGUAGE_NONE][0]['value']
        )
      );
    }

    return '';
  }

  protected function defaultUri() {
    return array('path' => 'user_alert/' . $this->user_alert_id);
  }

  public function path() {
    $uri = $this->uri();
    return $uri['path'];
  }

  public function url() {
    $uri = $this->uri();
    return url($uri['path'], $uri);
  }

  public function save() {
    parent::save();
  }

  public function delete() {
    parent::delete();
  }
}

class UserAlertController extends EntityAPIController {

  /**
   *
   * @param type $entityType
   */
  public function __construct($entityType) {
    parent::__construct($entityType);
  }

  /**
   *
   * @param type $entity
   * @param type $view_mode
   * @param type $langcode
   * @param type $content
   * @return string
   */
  public function buildContent($entity, $view_mode = 'full', $langcode = NULL, $content = array()) {
    $content = parent::buildContent($entity, $view_mode, $langcode, $content);
    return $content;
  }

  public function attachLoad(&$queried_entities, $revision_id = FALSE) {
    parent::attachLoad($queried_entities, $revision_id);
  }

  public function create(array $values = array()) {
    $values += array(
      'user_alert_id' => 0,
      'is_new' => TRUE,
      'label' => 'Message',
      'uid' => 1,
      'created' => time(),
      'changed' => time(),
    );

    $entity = parent::create($values);
    return $entity;
  }

  public function delete($ids, DatabaseTransaction $transaction = NULL) {
    $entities = $ids ? $this->load($ids) : FALSE;

    if (!$entities) {
      return;
    }

    parent::delete($ids, $transaction);
  }

  public function save($entity, DatabaseTransaction $transaction = NULL) {
    parent::save($entity, $transaction);
  }

  public function export($entity, $prefix = '') {
    $vars = get_object_vars($entity);
    unset($vars[$this->statusKey], $vars[$this->moduleKey], $vars['is_new'], $vars['type'], $vars['label']);
    if ($this->nameKey != $this->idKey) {
      unset($vars[$this->idKey]);
    }
    $info = $entity->entityInfo();
    $instances = field_info_instances($info['bundle of'], $entity->type);

    $fields = array();
    foreach ($instances as &$instance) {
      $field = field_info_field($instance['field_name']);
      unset($field['id'], $field['bundles'], $field['storage']);
      $fields[$instance['field_name']] = $field;
      unset($instance['bundle']);
    }

    $vars['fields'] = $fields;
    $vars['field_instances'] = $instances;

    return entity_var_json_export($vars, $prefix);
  }
}
